/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * ͒PĳUARTpͯ ̧قłB
 *
 * ̧ق͒PĳUARTp̒`ϸۂ܂݂܂BATmega32ȊȎϲ ۰ׂ
 * gpꍇA̧ق͕ύXKvłB߰ĂްڰĂ̧قŕύX
 * ܂B
 *
 * \par pLq:
 *      AVR274 : PĳUART
 *
 * \par 
 * IȺގAxׁ߲A߲אݒAx޲ɂĂ
 * readme.htmlB
 *
 * \author
 *      Atmel Corporation: http://www.atmel.com \n
 *      xEҰ: avr@atmel.com
 *
 * $Name:  $
 * $Revision: 1364 $
 * $RCSfile: single_wire_UART.h,v $
 * $Date: 2007-02-08 14:13:02 +0100 (to, 08 feb 2007) $  \n
 ******************************************************************************/

#include "stdint.h"			// ^錾

#ifndef FALSE
  #define FALSE 0
  #define TRUE !FALSE
#endif

// ްڰĐݒ (WAIT_ONE,PRESCALER):
// ްڰ  1MHz  2MHz  4MHz   8MHz
//   4800 207,1  51,8 103,8 (207,8)
//   9600 103,1 207,1  51,8  103,8
//  19200  s 103,1 207,1   51,8
//  28800  s  s 138,1   34,8
//  38400  s  s 103,1  207,1
// WAIT_ONE~PRESCALER100̎UARTwǑSĂCPU邱ƂɒӂĂB

/* ʐMҰ (WAIT_ONE`͉pLq̎2-1.ɏ]ĕύXȂ΂Ȃ܂B) */
#define WAIT_ONE			103		//!< ޯĎԻِ(̒ľvZɂĂ͉pLqB)
									// PRESCALERlWAIT_ONElɑ΂ĈӐ}lɐݒ肳邱ƂmɂĂB
#define PRESCALER			1		//!< T/COuݒ(ްڰĐݒɏ]Đݒ肳Ȃ΂Ȃ܂B)

/* ߰Ă݂̐ݒ */
#define SW_UART_PIN_NUMBER	2		//!< UARTʐMp߰ē(ޯ)ԍݒ肵ĂB
#define SW_UART_PORT		PORTD	//!< UARTʐMp߰ďoڼ޽ݒ肵ĂB
#define SW_UART_PIN			PIND	//!< UARTʐMp߰ēڼ޽ݒ肵ĂB
#define SW_UART_DDR			DDRD	//!< UARTʐMp߰ĕڼ޽ݒ肵ĂB(dpsgp)

#define TRANSMIT_DELAY		70		//!< Jnޯđo犄荞ݏł̎ޯđo܂ł̒xِ
#define RECEIVE_DELAY		76		//!< JnޯČoT/Cn܂łƊ荞݂ł̎ޯĎ擾܂ł̒xِ

#define WAIT_ONEHALF	(WAIT_ONE + WAIT_ONE/2)		// 1.5ޯĎ(ޯĎMp)

#define TIMER_PRESCALER_CONTROL_REGISTER	TCCR0	//!< UARTpɎgpT/Cɏ]Đڼ޽`ĂB
#if (PRESCALER == 1)
  #define START_UART_TIMER()     (TIMER_PRESCALER_CONTROL_REGISTER |=  (1<<CS00))	// /vJn(̊֘A`͈قȂT/CgpꍇɕύXKvłBްĂQƂĂB)
  #define STOP_UART_TIMER()      (TIMER_PRESCALER_CONTROL_REGISTER &= ~(1<<CS00))	// /v~
#elif (PRESCALER == 8)
  #define START_UART_TIMER()     (TIMER_PRESCALER_CONTROL_REGISTER |=  (1<<CS01))	// /vJn
  #define STOP_UART_TIMER()      (TIMER_PRESCALER_CONTROL_REGISTER &= ~(1<<CS01))	// /v~
#else
  #error PRESCALER must be set to 1 or 8	// PRESCALER1`8ɐݒ肳Ȃ΂Ȃ܂B
#endif

#if ( ((WAIT_ONEHALF-(RECEIVE_DELAY/PRESCALER)) > 255) || ((WAIT_ONE) > 255))
  #error WAIT_ONE is set too high. Try to increase prescaler or use a higher baud rate.
  // WAIT_ONE傫܂BOu傫邩A荂ްڰĂĂB
#endif

#if ( (WAIT_ONE) < (100/PRESCALER))
  #error A too high baud rate is used. Please check the PRESCALER and WAIT_ONE setting.
  // ްڰĂgpĂ܂BPRESCALERWAIT_ONE̐ݒ𒲂ׂĂB
#endif

/*  ϸ */
#define READ_UART_PIN()			( SW_UART_PIN & (1<<SW_UART_PIN_NUMBER) )		// UARTݒl擾

/* AVR߰Ēڗpϸ */
#define INITIALIZE_UART_PIN()	( SW_UART_PORT &= ~(1<<SW_UART_PIN_NUMBER) )	//!< o͐ݒ莞̏o͒l0ɐݒ
#define SET_UART_PIN()			( SW_UART_DDR  &= ~(1<<SW_UART_PIN_NUMBER) )	//!< UART݂Hi-Z()ݒ
#define CLEAR_UART_PIN()		( SW_UART_DDR  |=  (1<<SW_UART_PIN_NUMBER) )	//!< UART=Lowo
/* d(OɏՊgp)pϸ */
//#define INITIALIZE_UART_PIN()	( SW_UART_DDR  |=  (1<<SW_UART_PIN_NUMBER) )	//!< UART݂o͂ɐݒ
//#define SET_UART_PIN()		( SW_UART_PORT |=  (1<<SW_UART_PIN_NUMBER) )	//!< UART݂Higho͐ݒ
//#define CLEAR_UART_PIN()		( SW_UART_PORT &= ~(1<<SW_UART_PIN_NUMBER) )	//!< UART݂Lowo͐ݒ

/* UARTp荞޸` */
#define SW_UART_EXTERNAL_INTERRUPT_VECTOR		INT0_vect			//!< UARTpO荞޸(ꂪUARTݒ`ɑΉĂ̂mFĂB)
#define SW_UART_TIMER_COMPARE_INTERRUPT_VECTOR	TIMER0_COMP_vect	//!< UARTpT/Crv荞޸

/* / ϸ(޲ˑłB) */
#define CLEAR_UART_TIMER_ON_COMPARE_MATCH()		(TCCR0 |= (1<<WGM01))								//!< T/Cڼ޽rvł̌v(CTC)ݒ
#define SET_UART_TIMER_COMPARE_WAIT_ONE()		(OCR0 = WAIT_ONE)									//!< T/Crl1ޯĎԂɐݒ
#define SET_UART_TIMER_COMPARE_START_TRANSMIT()	(OCR0 = WAIT_ONE - (TRANSMIT_DELAY/PRESCALER))		//!< T/CrlޯđMpɐݒ
#define SET_UART_TIMER_COMPARE_START_RECEIVE()	(OCR0 = WAIT_ONEHALF - (RECEIVE_DELAY/PRESCALER))	//!< T/CrlޯĎMpɐݒ
#define CLEAR_UART_TIMER()						(TCNT0 = 0x00)										// T/Cl(=0)
#define ENABLE_UART_TIMER_INTERRUPT()			(TIMSK |= (1<<OCIE0))								// T/Crv荞݋
#define DISABLE_UART_TIMER_INTERRUPT()			(TIMSK &= ~(1<<OCIE0))								// T/Crv荞݋֎~
#define CLEAR_UART_TIMER_INTERRUPT_FLAG()		(TIFR = (1<<OCF0))									// T/Crv荞ݗv׸މ

/* O荞ϸ(޲ˑłB) */
#define INITIALIZE_UART_EXTERNAL_INTERRUPT()	(MCUCR |= (1<<ISC01))	//!< O荞0~[ɐݒ(JnޯČo)
#define ENABLE_UART_EXTERNAL_INTERRUPT()		(GICR |= (1<<INT0))		// O荞0
#define DISABLE_UART_EXTERNAL_INTERRUPT()		(GICR &= ~(1<<INT0))	// O荞0֎~
#define CLEAR_UART_EXTERNAL_INTERRUPT_FLAG()	(GIFR = (1<<INTF0))		// O荞0v׸މ(0)

/* ׸ޒ` */
#define SW_UART_TX_BUFFER_FULL		4	//!< ްMޯ̧瑗鏀Ăꍇɐݒ(1)
#define SW_UART_RX_BUFFER_FULL		5	//!< ްMޯ̧擾鏀Ăꍇɐݒ(1)
#define SW_UART_RX_BUFFER_OVERFLOW	6	//!< Mޯ̧ꂽꍇɐݒ(1)Aްr܂B
#define SW_UART_FRAME_ERROR			7	//!< ڰݸތ肪Nꍇɐݒ(1)

/* ׸ ϸ */
#define SET_FLAG(flag_register,flag_bit)	( (flag_register) |= (1 << (flag_bit)) )	//!< ڼ޽׸ނݒ(1)鎞ɂϸۂgp܂B
#define CLEAR_FLAG(flag_register,flag_bit)	( (flag_register) &= ~(1 << (flag_bit)) )	//!< ڼ޽׸ނ(0)鎞ɂϸۂgp܂B
#define READ_FLAG(flag_register,flag_bit)	( (flag_register) & (1 << (flag_bit)) )		//!< ڼ޽׸ނǂގɂϸۂgp܂B

extern volatile uint8_t SW_UART_status;		//!< ׸ނێ޲ĕϐ

// pڼ޽UART_counteruɂ͂gpĂBcouterϐ̉
// ̐錾(single_wire_UART.cł̐錾)𒍎߂ɂ邱ƂƁAꂪgp鎞
// R15֌Œ肷邱ƂYȂłBIAR optionsƭC/C++ compil
// erޓcode sectionōs܂B
//__no_init __regvar volatile uint8_t SW_UART_status @ 15;

// pڼ޽UART_statusuɂ͂gpĂBstatusϐ̉ߋ
// ̐錾𒍎߂ɂ邱ƂƁAꂪgp鎞R14֌Œ肷邱ƂYȂ
// BIAR optionsƭC/C++ compilerޓcode sectionōs
// ܂B
//__no_init __regvar volatile uint8_t UART_counter @ 14;

// UART_statusGPIORɒuɂ͂gpĂBp\ȂAGPIOṞ
// 𓾂邽߂޲ްĂ𒲂ׂĂ(ł$001Eɐݒ)BGPIORg
// p鎞͂statusϐ̉ߋ̐錾(single_wire_UART.cł̐錾)𒍎߂
// ĂB
//__io __no_init static volatile uint8_t SW_UART_status @ 0x1E;

/* SUART֐ */
void    SW_UART_Enable(void);		//!< UART
void    SW_UART_Disable(void);		//!< UART֎~
void    SW_UART_Transmit(uint8_t);	//!< 1޲đM
uint8_t SW_UART_Receive(void);		//!< 1޲ĎM
